#include "action.hpp"

namespace goap {
Action::Action(WorldState &requires, WorldState &effects)
: requires{requires}, effects{effects} {}

WorldState const &Action::get_required() const {
    return this->requires;
}

WorldState const &Action::get_effects() const {
    return this->effects;
}

ActionID Action::get_id() const {
    return this->id;
}

ActionData::ActionData(Action *action)
: data{action} {}

ActionData::~ActionData() {
    if(this->data != nullptr)
        delete this->data;
}
}

bool TestAction::is_done_for(goap::ActorWorldState *) {
    return true;
}
bool TestAction::is_possible_for(goap::ActorWorldState *) {
    return true;
}
goap::State *TestAction::get_apply_state() const {
    return nullptr;
}

