#include "action_db.hpp"

namespace goap {
StaticString::~StaticString() {
    if(this->ptr != nullptr)
        delete this->ptr;
}

gd::String &StaticString::get() {
    if(this->ptr == nullptr)
        this->ptr = new gd::String();
    return *this->ptr;
}

ActionID ActionDB::register_action(Action *instance, gd::String name) {
    instance->id = ActionDB::actions.size();
    if(!ActionDB::hint.get().is_empty())
        ActionDB::hint.get() += ",";
    ActionDB::hint.get() += name;
    ActionDB::actions.push_back(ActionData(instance));
    return instance->get_id();
}

Action const *ActionDB::get_action(ActionID index) {
    if(ActionDB::actions.size() >= index || index < 0)
        return nullptr;
    return ActionDB::actions[index].data;
}

gd::String const &ActionDB::get_enum_hint() {
    return ActionDB::hint.get();
}

gd::Vector<ActionData> ActionDB::actions{gd::Vector<ActionData>()};
StaticString ActionDB::hint{};
}
